#ifndef _ARENA_TABLE_H_
#define	_ARENA_TABLE_H_

#include <types.h>

struct TickSave
{
	// Holding bay for registers saved during a clock tick upcall
	Vaddr		eip;
	uint32		esp;
};

struct ArenaData
{
	// Entry points
	Vaddr		activate_upcall;
	Vaddr		time_slice_start;
	Vaddr		time_slice_end;
	Vaddr		clock_tick_upcall;
	Vaddr		irq_upcall;
	Vaddr		iac_upcall;
	Vaddr		exception_upcall;

	bool		activate_set;
	bool		tss_set;
	bool		tse_set;
	bool		clock_set;
	bool		irq_set;
	bool		iac_entry_set;
	bool		exception_set;

	// Register save area for upcalls
	TickSave	save_area;

	// Scheduling data
	int		overrun;		// used by Scheduler to count time slice over-run

	// Page table
	int		pfn_page_dir;		// PFN of page used for page directory

	// Allocation details
	bool		free;			// TRUE if not in use.
};

#endif /* _ARENA_TABLE_H_ */
